#####################################
#    Simulateur de robot autonome   #
#    autheur : YLG                  #
#     Version : 1.1                 #
#####################################

#####################################
# Importation de fonctions externes: 

import pygame, random, sys
from pyMobileRobot import *
from math import *
from pygame.locals import *

#####################################
# Definition locale de fonctions: 

# ====== Creation du decor =======        
def set_decor(width, height):
    # Creation de la surface de decor 
    decor = pygame.Surface((width, height))        

    #trace du contour noir sur fond blanc
    decor.fill((0,0,0))
    pygame.draw.rect(decor,(255,255,255),(5,5,width - 10,height - 10))

    # trace aleatoire de nObs polygones dans decor
    nObs = 12
    rObsMin = 15
    rObsMax = 30
     
    for n in range(nObs):
        rObs = random.randint(rObsMin, rObsMax)
        while True:
            tmpC = Point2D(random.randint(5+2*rObs,width-5-2*rObs), random.randint(5+2*rObs,height-5-2*rObs))
            if (abs(tmpC.x - width/2) > (2*myRobot.L+rObs)) or (abs(tmpC.y - height/2) > (2*myRobot.L+rObs)):
                break  
        nVertices = random.randint(3,6)
        points = []
        for i in range(nVertices):
            points.append((tmpC.x+rObs*(1+0.5*random.random())*math.cos(i*2*pi/nVertices + 0.2*random.random()),\
                           tmpC.y+rObs*(1+0.5*random.random())*math.sin(i*2*pi/nVertices + 0.2*random.random())))

        pygame.draw.polygon(decor,(random.randint(0,255),random.randint(0,255),random.randint(0,255)),(points),0)

    return decor

# ====== Gestion du clavier ======= 
def gestion_clavier():
    global trace, run
    global tPressed, gPressed, pPressed
    # Appui sur 't' : mode affichage de la trace des capteurs
    keyPressed = pygame.key.get_pressed()
    if(keyPressed[pygame.K_t] != 0):
        if not tPressed:  # Gestion de la repetition de l'appui
            # code execute a chaque nouvel appui sur la touche 't'
            trace = (trace + 1) % 3
            tPressed = True
    else:
        tPressed = False

    # Appui sur 'p' : mode pas a pas
    if(keyPressed[pygame.K_p] != 0):
        if not pPressed:  # Gestion de la repetition de l'appui
            # code execute a chaque nouvel appui sur la touche 'p'
            myRobot.update(False)
            run = False
            pPressed = True
    else:
        pPressed = False

    # Appui sur 'g' : mode runtime
    if(keyPressed[pygame.K_g] != 0):
        if not gPressed:  # Gestion de la repetition de l'appui
            # code execute a chaque nouvel appui sur la touche 'p'
            run = not run
            gPressed = True
    else:
        gPressed = False


#####################################
#  Parite Pour variable floue STEPH:

def appartenance(distance):
    '''
    fonction d'appatenance des capteurs
    '''
#     if distance <= 200:
#         Petit = 100
#         Grand = 0
#     
#     else:
#         Petit = 0
#         Grand = 100
#     return Petit,Grand

def appartenance(distance):
    if distance <= 50:
        Petit = 100
        Grand = 0
    elif 50 <= distance <= 300:
        Petit = -0.4*distance + 120
        Grand = 0.4*distance - 20
    else:
        Petit = 0
        Grand = 100
    return Petit,Grand

# def appartenance(distance):
#     '''
#     fonction d'appatenance des capteurs
#     '''
#     if distance <= 100:
#         Petit = 100
#         Grand = 0
#     elif 100 <= distance <= 300:
#         Petit = -0.5*distance + 150
#         Grand = 0.5*distance - 50
#     else:
#         Petit = 0
#         Grand = 100
#     return Petit,Grand

def appartenanceAlpha(distance):
    '''
    fonction d'appatenance des moteurs
    '''
    if distance == 0:
        Petit = 100
        Moyen = 0
        Grand = 0
    elif distance == 50:
        Petit = 0
        Moyen = 100
        Grand = 0
    elif distance == 100:
        Petit = 0
        Moyen = 0
        Grand = 100
    else:
        Petit = 0
        Moyen = 0
        Grand = 0
    return Petit,Moyen,Grand

# Liste des règles de comportement
#
def regle1(dGauche,dAvant,dDroite):
    pourcentage=min(appartenance(dGauche)[1],appartenance(dAvant)[1],appartenance(dDroite)[1])
    #retouner vitesse_gauche,vitesse_droite,pourcentage
    return 1,1,pourcentage
def regle2(dGauche,dAvant,dDroite):
    pourcentage=min(appartenance(dGauche)[1],appartenance(dAvant)[0],appartenance(dDroite)[1])
    val = random.randint(0,1)
    return val, not val ,pourcentage
def regle3(dGauche,dAvant,dDroite):
    pourcentage=min(appartenance(dGauche)[1],appartenance(dAvant)[1],appartenance(dDroite)[0])
    return 0.5,1,pourcentage
def regle4(dGauche,dAvant,dDroite):
    pourcentage=min(appartenance(dGauche)[1],appartenance(dAvant)[0],appartenance(dDroite)[0])
    return 0,1,pourcentage
def regle5(dGauche,dAvant,dDroite):
    pourcentage=min(appartenance(dGauche)[0],appartenance(dAvant)[1],appartenance(dDroite)[1])
    return 1,0.5,pourcentage
def regle6(dGauche,dAvant,dDroite):
    pourcentage=min(appartenance(dGauche)[0],appartenance(dAvant)[0],appartenance(dDroite)[1])
    return 1,0,pourcentage
def regle7(dGauche,dAvant,dDroite):
    pourcentage=min(appartenance(dGauche)[0],appartenance(dAvant)[1],appartenance(dDroite)[0])
    return 0.5,0.5,pourcentage
def regle8(dGauche,dAvant,dDroite):
    pourcentage=min(appartenance(dGauche)[0],appartenance(dAvant)[0],appartenance(dDroite)[0])
    return 1,0,pourcentage

def listeRegle(dGauche,dAvant,dDroite):
    liste=[]
    liste.append(regle1(dGauche,dAvant,dDroite))
    liste.append(regle2(dGauche,dAvant,dDroite))
    liste.append(regle3(dGauche,dAvant,dDroite))
    liste.append(regle4(dGauche,dAvant,dDroite))
    liste.append(regle5(dGauche,dAvant,dDroite))
    liste.append(regle6(dGauche,dAvant,dDroite))
    liste.append(regle7(dGauche,dAvant,dDroite))
    liste.append(regle8(dGauche,dAvant,dDroite))
    return liste

# Fusionner les résultats
def fusionner(liste,cote,vitesse):
    resultat=[]
    for x in liste:
        if x[cote]==vitesse:
            resultat.append(x[2])
    return max(resultat)

def defuzzifier(dGauche,dAvant,dDroite):
    alpha_gauche = (fusionner(listeRegle(dGauche,dAvant,dDroite),0,1  ) * 1 +
                    fusionner(listeRegle(dGauche,dAvant,dDroite),0,0.5) * 0.5 +
                    fusionner(listeRegle(dGauche,dAvant,dDroite),0,0  ) * 0) / (fusionner(listeRegle(dGauche,dAvant,dDroite),0,1)
                                                               +fusionner(listeRegle(dGauche,dAvant,dDroite),0,0.5)
                                                               +fusionner(listeRegle(dGauche,dAvant,dDroite),0,0))
                    
    alpha_droit  = (fusionner(listeRegle(dGauche,dAvant,dDroite),1,1  ) * 1+
                    fusionner(listeRegle(dGauche,dAvant,dDroite),1,0.5) * 0.5 +
                    fusionner(listeRegle(dGauche,dAvant,dDroite),1,0  ) * 0) / (fusionner(listeRegle(dGauche,dAvant,dDroite),1,1)
                                                               +fusionner(listeRegle(dGauche,dAvant,dDroite),1,0.5)
                                                               +fusionner(listeRegle(dGauche,dAvant,dDroite),1,0))                                                           
    return alpha_gauche,alpha_droit

def fuzzyDecision2():
    
#     #global m_V, m_phi
#     app = []
#     verite = []
#     dMin = myRobot.L
#     dMax = 3*myRobot.L
#     
#     # Calcul des degres d'appartenance 
#     app.append(fuzzyMeasure(myRobot.leftDist, dMin, dMax))
#     app.append(fuzzyMeasure(myRobot.frontDist, dMin, dMax))
#     app.append(fuzzyMeasure(myRobot.rightDist, dMin, dMax))
    global w_n0

#     dMin = myRobot.L
#     dMax = 3*myRobot.L
    dMin = 0
    dMax = 400 
    vitesseGauche = 5*defuzzifier(myRobot.leftDist,myRobot.frontDist,myRobot.rightDist)[0]
    vitesseDroite = 5*defuzzifier(myRobot.leftDist,myRobot.frontDist,myRobot.rightDist)[1]
    
    V = 15*myRobot.D*(vitesseGauche+vitesseDroite)/4
    Phi = 1*10*(vitesseDroite-vitesseGauche)/(2*25)
    
#     V = 4*myRobot.D*(vitesseGauche+vitesseDroite)/4
#     w_n1 = -myRobot.D*(vitesseDroite-vitesseGauche)/(2*myRobot.l)
#    Phi = (min(w_n0,w_n1) + abs(w_n0-w_n1))
    myRobot.set_command(Phi, V)
#    w_n0 = w_n1
    print("G: %.0f C: %.0f D: %.0f" %(myRobot.leftDist,myRobot.frontDist,myRobot.rightDist),
          "==>","(Vg: %.2f,Vd: %.2f)" %(defuzzifier(myRobot.leftDist,myRobot.frontDist,myRobot.rightDist)),"vitesse: %.4f direction: %.4f" %(V,Phi))
    
        
#####################################
# Corps principal du programme: 

""" VARIABLES GLOBALES """
tPressed = False   # gestion touche 't'
pPressed = False   # gestion touche 'p'
gPressed = False   # gestion touche 'g'
run = False        # gestion mode run/debug
moving = 5         # deplacement fenetre
speed = 100
i = 1
w_n0 = 0    #direction a t=0 pour la dérivé

""" VARIABLES DE COMMANDE """
# Angles et vitesses
m_phi = 80, -60, 0, -20, 60, 20, 80, 0 
m_V = 50, 200, 700, 700, 300, 700, 50, 1000 

""" CREATION FENETRE DE SIMULATION """
size = width, height = 800, 800                                 # Dimensions de la fenetre
screen = pygame.display.set_mode((width, height))               # Creation de la fenetre
pygame.display.set_caption("Robot autonome")                    # Nom de la fenetre 
pygame.display.set_icon(pygame.image.load("./res/icone.png"))   # Icone de la fenetre

""" CREATION ROBOT """
myRobot = MobileRobot(width/2, height/2, 0)                     # position initiale robot
myRobot.set_framerate(60)                                       # frequence animation = 60 images/s
trace = 0                                                       # gestion affichage des capteurs
        
""" INITIALISATION DECOR ET PREMIERE FRAME """
decor = set_decor(width, height)   # Creation du decor
screen.blit(decor,(0,0))           # Dessin du decor dans l'ecran
myRobot.draw(screen, True, True)   # Dessin du robot dans l'ecran
pygame.display.flip()              # Affichage fenetre

"""=============================
        BOUCLE DE SIMULATION  
   ============================="""
Running = True
while Running:
    """ Calcul nouvelle position robot """
    if run:
        myRobot.update()
             
    """ Dessin du robot sur decor """
    # Copie du decor dans l'ecran
    screen.blit(decor,(0,0))
    # scan pour les 3 capteurs (avec trace eventuel)
    myRobot.us_sensor(decor, screen, 30, 200, alpha = pi/8, beta = pi/5, flip = True, trace = trace)
    # Test de collision
    if myRobot.collision(decor, True):
        moving = 5 - moving
        screen.blit(screen, (moving, moving))	# vibration de la fenetre

    # Dessin du robot dans l'ecran
    myRobot.draw(screen, True, True)

    """ Affichage a l'ecran """
    pygame.display.flip()
    
    """ Loi comportementale du robot """
    fuzzyDecision2()
    
    """ Gestion du clavier """
    gestion_clavier()
    
    """ Test de fermeture de la fenetre """
    if pygame.event.peek(QUIT):
        Running = False
    
    pygame.event.clear()
	
"""=============================
	   FIN BOUCLE DE SIMULATION  
   ============================="""

"""" Fermeture fenetre """
pygame.display.quit()
print("Fin normale du programme")

